/*
 * Knapsack - dinamicko programiranje
 * Tomislav Novak
 */
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cassert>
using namespace std;

#define MAXSIZE 10000
#define MAXN    1000

struct k {
    int cost, value;
};

int  memo[MAXSIZE+1][MAXN];
bool pi[MAXSIZE+1][MAXN];
bool uzeo[MAXN];
int  n, W;
k    knapsack[MAXN];

int f(int w, int u) {
    if (u < 0)            return 0;
    if (memo[w][u] != -1) return memo[w][u];

    int best = f(w, u-1);
    pi[w][u] = false;

    if (w >= knapsack[u].cost) {
        int q = f(w-knapsack[u].cost, u-1) + knapsack[u].value;
        if (q > best)
            best = q, pi[w][u] = true;
    }

    return memo[w][u] = best;
}

int main() {
    scanf("%d%d", &W, &n);
    assert(W <= MAXSIZE);

    for (int i = 0; i < n; ++i)
        scanf("%d%d", &knapsack[i].cost, &knapsack[i].value);

    memset(memo, -1, sizeof memo);
    printf("%d\n", f(W, n-1));

    int u = n-1, p = W;
    while (u >= 0) {
        if (pi[p][u]) {
            uzeo[u] = true;
            p -= knapsack[u].cost;
        }

        u--;
    }
    
    for (int i = 0; i < n; ++i)
        if (uzeo[i])
            printf("%d ", i+1);
    printf("\n");

    return EXIT_SUCCESS;
}
