/*
 * Knapsack - hill climbing
 * Tomislav Novak
 */
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <climits>
#include <ctime>
using namespace std;

#define MAXN 1000000
#define INF  INT_MAX/2

struct k {
    int cost, value;
};

k    knapsack[MAXN];
bool stanje[MAXN];
int  cost, value;
int  n, W;

int irand(int n) {
    return (int)((double)n * (rand() / (RAND_MAX + 1.0)));
}

void calc(int &cost, int &value) {
    cost = value = 0;
    for (int i = 0; i < n; ++i) {
        cost  += knapsack[i].cost  * stanje[i];
        value += knapsack[i].value * stanje[i];
    }

    if (cost > W)
        value = -INF;
}

int main() {
    scanf("%d%d", &W, &n);
    assert(n <= MAXN);

    for (int i = 0; i < n; ++i)
        scanf("%d%d", &knapsack[i].cost, &knapsack[i].value);

    srand(time(NULL));

    int 
        cost  = 0,
        value = 0;

    // pocetno stanje - slucajno generirano dopustivo
    for (int i = 0; i < n; ++i) {
        int q = irand(n);

        if (stanje[q] == 0 && cost+knapsack[q].cost <= W)
            stanje[q] = 1, cost += knapsack[q].cost;
        else if (stanje[q] == 1)
            stanje[q] = 0, cost -= knapsack[q].cost;
    }

    for (int i = 0; i < n; ++i)
        fprintf(stderr, "%d ", stanje[i]);

    calc(cost, value);
    fprintf(stderr, "\tCOST = %d, VALUE = %d\n\n", cost, value);

    // ponavljaj sve dok ne dodjes do lokalnog maksimuma
    while (1) {
        int c, v, k = -1;
        for (int i = 0; i < n; ++i) {
            stanje[i] ^= 1;  // promijenimo i-ti bit

            calc(c, v);
            if (v >= value)
                value = v, cost = c, k = i;

            stanje[i] ^= 1;
        }

        if (k == -1) break;

        stanje[k] ^= 1;
        for (int i = 0; i < n; ++i)
            fprintf(stderr, "%d ", stanje[i]);
        fprintf(stderr, "\tCOST = %d, VALUE = %d\n", cost, value);
    }

    printf("%d\n", value);
    for (int i = 0; i < n; ++i)
        if (stanje[i])
            printf("%d ", i+1);
    printf("\n");

    return EXIT_SUCCESS;
}
