#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cassert>
using namespace std;

#define BIG  0x3fffffff
#define MAXN 20

int memo[MAXN][1<<MAXN];
int g[MAXN][MAXN];
int n, max_state;

int rek(int u, int state) {
    if (state == max_state)   return g[u][0];
    if (memo[u][state] != -1) return memo[u][state];

    int best = BIG;
    for (int v = 0; v < n; ++v) {
        if ((state >> v) & 1) continue;
        best = min(best, g[u][v] + rek(v, state | (1<<v)));
    }

    return memo[u][state] = best;
}

int main() {
    scanf("%d", &n);
    assert(n <= MAXN);

    max_state = (1<<n) - 1;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            scanf("%d", &g[i][j]);

    memset(memo, -1, sizeof memo);
    printf("%d\n", rek(0, 1));

    return EXIT_SUCCESS;
}
